header {

version(ANTLR_TokenTypes)
{}
else
{
  private import PParserTokenTypes;   // TODO
}

  
}


options {
    language = "DLang";
}


class PParser extends Parser;
{
	public void traceOut(WString rname) {
		System.outp.println("exit "~rname~"; LT(1)="~LT(1).toWString());
	}
	public void traceIn(WString rname)  {
		System.outp.println("enter "~rname~"; LT(1)="~LT(1).toWString());
	}
/*
	public void consume() {
		try {
			System.outp.println(LT(1));
		}
		catch (IOException ignore) {}
		super.consume();
	}
*/
}

startRule
	:	( decl )+
	;

decl:	INT a:ID {System.outp.println("decl "~a.getText());}
		( COMMA b:ID {System.outp.println("decl "~b.getText());} )*
		SEMI
	;

{

private import Static;

private import std.stream;

alias antlrrt.runtime.InputStream InputStream;

}

class PLexer extends Lexer;
options {
	charVocabulary = '\3'..'\377';
	k=2;
}

tokens {
	INT="int";
}

{
	public void uponEOF() {
		if ( cast(Object)Static.selector.getCurrentStream() != Static.mainLexer ) {
			// don't allow EOF until main lexer.  Force the
			// selector to retry for another token.
			Static.selector.pop(); // return to old lexer/stream
			Static.selector.retry();
		}
		else {
			System.outp.println(asWString("Hit EOF of main file"));
		}
	}
}

SEMI:	';'
	;

COMMA
	:	','
	;

ID
	:	('a'..'z')+
	;

INCLUDE
	:	"#include" (WS)? f:STRING
		{

		// create lexer to handle include
		WString name = f.getText();
		InputStream input=null;
		try {
		    input = new File(name.toString());
		}
		catch (IOException fnf) {   // TODO: Right exception?
			System.err.println("cannot find file "~name);
		}
		PLexer sublexer = new PLexer(input);
		// make sure errors are reported in right file
		sublexer.setFilename(name);
		Static.parser.setFilename(name);

		// you can't just call nextToken of sublexer
		// because you need a stream of tokens to
		// head to the parser.  The only way is
		// to blast out of this lexer and reenter
		// the nextToken of the sublexer instance
		// of this class.

		Static.selector.push(sublexer);
		// ignore this as whitespace; ask selector to try
		// to get another token.  It will call nextToken()
		// of the new instance of this lexer.
		Static.selector.retry(); // throws TokenStreamRetryException
		}
	;

STRING
	:	'"'! ( ~'"' )* '"'!
	;

WS	:	(	' '
		|	'\t'
		|	'\f'
			// handle newlines
		|	(	options {generateAmbigWarnings=false;}
			:	"\r\n"  // Evil DOS
			|	'\r'    // Macintosh
			|	'\n'    // Unix (the right way)
			)
			{ newline(); }
		)+
		{ $setType(Token.SKIP); }
	;
